/*-----------------------------------------------------------------*/
/*! 
  \file scscpfileio.h
  \internal
  \brief Open Math Input Stream with file descriptor (int) definition.
  \author  M. Gastineau 
           Astronomie et Systemes Dynamiques, IMCCE, CNRS, Observatoire de Paris. 

   Copyright, 2008, 2009,  M. Gastineau, IMCCE-CNRS
   email of the author : gastineau@imcce.fr
*/
/*-----------------------------------------------------------------*/

/*-----------------------------------------------------------------*/
/* License  of this file :
This file is governed by the CeCILL-C license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute this file under the terms of the CeCILL-C
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL-C license and that you accept its terms.

*/
/*-----------------------------------------------------------------*/


#ifndef __omlfileio_H__
#define __omlfileio_H__

/*-----------------------------------------------------------------*/
/*! handle IO to a file or a socket
*/
/*-----------------------------------------------------------------*/
typedef struct 
{
   /*-----------------------------------------------------------------*/
   /* attributes */
   /*-----------------------------------------------------------------*/
   int m_fd; //!< file descriptor
   int m_issocket; //!< = ture if socket
} SCSCP_fileio;

//! attach the stream to an opened file descriptor
void SCSCP_fileio_setfile(SCSCP_fileio *io,int fd, int bsocket);
//! write a buffer 
int SCSCP_fileio_write(SCSCP_fileio *io,const char *buf, size_t len);
//! read a buffer
int SCSCP_fileio_read(SCSCP_fileio *io,char *buf, size_t len);
  

#endif /*__omlfileio_H__*/
